<?php

//-----------------------
if ( ! class_exists( 'WP_List_Table' ) ) {
	require_once( ABSPATH . 'wp-admin/includes/class-wp-list-table.php' );
}
//-----------------------





//----------------------------------------------------------
class tags_List extends WP_List_Table {

	public function __construct() {
		
		ob_start();

		parent::__construct( array(
			'singular' => __( 'tag', 'sp' ), //singular name of the listed records
			'plural'   => __( 'tags', 'sp' ), //plural name of the listed records
			'ajax'     => false //does this table support ajax?
		) );

}
//-----------------------
	


//-----------------------
public static function get_smartbot_tags( $per_page = 10, $page_number = 1 ) {

		global $wpdb;

		$sql = "SELECT ".$wpdb->prefix."smartbot_tags.ID , ".$wpdb->prefix."smartbot_tags.keywords AS name , ".$wpdb->prefix."smartbot_tags.thumbnail_width , ".$wpdb->prefix."smartbot_tags.thumbnail_height , ".$wpdb->prefix."terms.name AS term FROM ".$wpdb->prefix."smartbot_tags , ".$wpdb->prefix."terms WHERE ".$wpdb->prefix."smartbot_tags.term_id=".$wpdb->prefix."terms.term_id ";

		if ( ! empty( $_REQUEST['orderby'] ) ) {
			$sql .= ' ORDER BY ' . esc_sql( $_REQUEST['orderby'] );
			$sql .= ! empty( $_REQUEST['order'] ) ? ' ' . esc_sql( $_REQUEST['order'] ) : ' ASC';
		}

		$sql .= " LIMIT $per_page";
		$sql .= ' OFFSET ' . ( $page_number - 1 ) * $per_page;


		$result = $wpdb->get_results( $sql, 'ARRAY_A' );

		return $result;
	}
//-----------------------


//-----------------------
public static function delete_smartbot_tag( $id ) {
		global $wpdb;
		
		$wpdb->delete(
			"".$wpdb->prefix."smartbot_tags",
			array( 'ID' => $id ),
			array( '%d' )
		);
}
//-----------------------


//-----------------------
public static function record_count() {
		global $wpdb;

		$sql = "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_tags , ".$wpdb->prefix."terms WHERE ".$wpdb->prefix."smartbot_tags.term_id=".$wpdb->prefix."terms.term_id ";

		return $wpdb->get_var( $sql );
}
//-----------------------
	


//-----------------------
public function no_items() {
		_e( 'هیچ کلیدواژه ای ثبت نشده است', 'sp' );
}
//-----------------------


//-----------------------
public function column_default( $item, $column_name ) {
		switch ( $column_name ) {
			case 'term':
			case 'thumbnail_width':
			case 'thumbnail_height':
			case 'name':
			return $item[ $column_name ];
			default:
				return print_r( $item, true ); //Show the whole array for troubleshooting purposes
		}
		
}
//-----------------------


//-----------------------
function column_cb( $item ) {
		return sprintf(
			'<input type="checkbox" name="bulk-delete[]" value="%s" />', $item['ID']
		);
}
//-----------------------



//-----------------------
function column_name( $item ) {

		$delete_nonce = wp_create_nonce( 'sp_delete_smartbot_tag' );

		$title = '<strong>' . $item['name'] . '</strong>';

		$actions = array(
			'delete' => sprintf( '<a href="?page=%s&action=%s&tag=%s&_wpnonce=%s">Delete</a>', esc_attr( $_REQUEST['page'] ), 'delete', absint( $item['ID'] ), $delete_nonce )
		);

		return $title . $this->row_actions( $actions );
}
//-----------------------



//-----------------------
function get_columns() {
		$columns = array(
			'cb'      => '<input type="checkbox" />',
			'name'    => __( 'کلیدواژه ها', 'sp' ),
			'term' => __( 'دسته مربوطه', 'sp' ),
			'thumbnail_width'    => __( 'عرض تصاویر شاخص', 'sp' ),
			'thumbnail_height'    => __( 'طول تصاویر شاخص', 'sp' )
		);

		return $columns;
}
//-----------------------



//-----------------------
public function get_sortable_columns() {
		$sortable_columns = array(
			'name' => array( 'name', true ),
			'term' => array( 'term', false )
		);

		return $sortable_columns;
}
//-----------------------



//-----------------------
public function get_bulk_actions() {
		$actions = array(
			'bulk-delete' => 'Delete'
		);

		return $actions;
}
//-----------------------



//-----------------------
public function prepare_items() {

		$this->_column_headers = $this->get_column_info();

		/** Process bulk action */
		$this->process_bulk_action();

		$per_page     = $this->get_items_per_page( 'tags_per_page', 10 );
		$current_page = $this->get_pagenum();
		$total_items  = self::record_count();

		$this->set_pagination_args( array(
			'total_items' => $total_items, //WE have to calculate the total number of items
			'per_page'    => $per_page //WE have to determine how many items to show on a page
		) );

		$this->items = self::get_smartbot_tags( $per_page, $current_page );
}
//-----------------------



//-----------------------
public function process_bulk_action() {

		//Detect when a bulk action is being triggered...
		if ( 'delete' === $this->current_action() ) {

			// In our file that handles the request, verify the nonce.
			$nonce = esc_attr( $_REQUEST['_wpnonce'] );

			if ( ! wp_verify_nonce( $nonce, 'sp_delete_smartbot_tag' ) ) {
				die( 'Go get a life script kiddies' );
			}
			else {
				self::delete_smartbot_tag( absint( $_GET['tag'] ) );

				wp_redirect( esc_url( add_query_arg() ) );
				exit;
			}

		}

		// If the delete bulk action is triggered
		if ( ( isset( $_POST['action'] ) && $_POST['action'] == 'bulk-delete' )
		     || ( isset( $_POST['action2'] ) && $_POST['action2'] == 'bulk-delete' )
		) {

			$delete_ids = esc_sql( $_POST['bulk-delete'] );

			// loop over the array of record IDs and delete them
			foreach ( $delete_ids as $id ) {
				self::delete_smartbot_tag( $id );

			}

			wp_redirect( esc_url( add_query_arg() ) );
			exit;
		}
	}
	

}
//----------------------------------------------------------






//----------------------------------------------------------
class admin_panel {
	
public $tags_obj;
	
//-----	
public function __construct() {	
		add_action( 'admin_menu', array( $this, 'register_my_custom_menu_page' ) );
}
//-----	
	

//-----
public function register_my_custom_menu_page() {	

add_menu_page( 'تنظمیات ربات هوشمند', 'ربات هوشمند', 'manage_options', 'smartbot/admin/setting.php', '', plugins_url( 'smartbot/images/icon.png' ) );
	
add_submenu_page( 'smartbot/admin/setting.php', 'مدیریت کلیدواژه ها', 'مدیریت کلیدواژه ها', 'manage_options', 'tags', array( $this, 'tags_callback' ) );

$this->screen_option();
	
add_submenu_page( 'smartbot/admin/setting.php', 'ایجاد کلیدواژه جدید', 'ایجاد کلیدواژه جدید', 'manage_options', 'new-tag', array( $this, 'new_tag_callback' ) );
	
add_submenu_page( 'smartbot/admin/setting.php', 'انتخاب منابع', 'انتخاب منابع', 'manage_options', 'sources', array( $this, 'sources_callback' ) );

}
//-----


//-----
public function screen_option() {

		$option = 'per_page';
		$args   = array(
			'label'   => 'tags',
			'default' => 10,
			'option'  => 'tags_per_page'
		);

		add_screen_option( $option, $args );

		$this->tags_obj = new tags_List();
}
//-----
	
	
//-----
public function tags_callback() {		
include_once( plugin_dir_path( __FILE__ ) . '../admin/tags.php');
}
//-----

//-----
public function new_tag_callback() {
global  $wpdb;	
include_once( plugin_dir_path( __FILE__ ) . '../admin/new-tag.php');
}
//-----

//-----
public function sources_callback() {
global  $wpdb;	
include_once( plugin_dir_path( __FILE__ ) . '../admin/sources.php');
}
//-----


}
//----------------------------------------------------------