<?php

//-------------------
function insert_db_smartbot() {
global $wpdb;
global $smartbot_version;

$charset_collate = $wpdb->get_charset_collate();

//--
$smartbot_crawls_table = $wpdb->prefix . "smartbot_crawls";

$sql1= "CREATE TABLE  $smartbot_crawls_table (
`ID` INT NOT NULL AUTO_INCREMENT ,
`time` INT NOT NULL ,
`tag_id` INT NOT NULL ,
PRIMARY KEY (  `ID` )
) $charset_collate;";
//--

//--
$smartbot_posts_table = $wpdb->prefix . "smartbot_posts";

$sql2= "CREATE TABLE  $smartbot_posts_table (
`ID` INT NOT NULL AUTO_INCREMENT ,
`system_id` INT NOT NULL ,
`post_id` INT NOT NULL ,
PRIMARY KEY (  `ID` )
) $charset_collate;";
//--

//--
$smartbot_settings_table = $wpdb->prefix . "smartbot_settings";

$sql3= "CREATE TABLE  $smartbot_settings_table (
`ID` INT NOT NULL AUTO_INCREMENT ,
`item` VARCHAR( 30 ) NOT NULL ,
`value` VARCHAR( 60 ) NOT NULL ,
PRIMARY KEY (  `ID` )
) $charset_collate;";
//--

//--
$smartbot_sources_table = $wpdb->prefix . "smartbot_sources";

$sql4= "CREATE TABLE  $smartbot_sources_table (
`ID` INT NOT NULL AUTO_INCREMENT ,
`address` VARCHAR( 50 ) NOT NULL ,
PRIMARY KEY (  `ID` )
) $charset_collate;";
//--

//--
$smartbot_tags_table = $wpdb->prefix . "smartbot_tags";

$sql5= "CREATE TABLE  $smartbot_tags_table (
`ID` INT NOT NULL AUTO_INCREMENT ,
`keywords` VARCHAR( 200 ) NOT NULL ,
`term_id` INT NOT NULL ,
`thumbnail_width` INT NOT NULL ,
`thumbnail_height` INT NOT NULL ,
PRIMARY KEY (  `ID` )
) $charset_collate;";
//--

require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
dbDelta( $sql1 ); 
dbDelta( $sql2 );
dbDelta( $sql3 ); 
dbDelta( $sql4 );
dbDelta( $sql5 );

$check_settings_1=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_settings WHERE item='posts_status' " );
if(!$check_settings_1) $wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_settings SET item='posts_status' , value='1'  "); 

$check_settings_2=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_settings WHERE item='insert_reporter_name' " );
if(!$check_settings_2) $wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_settings SET item='insert_reporter_name' , value='0'  ");

$check_settings_3=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_settings WHERE item='remove_external_links' " );
if(!$check_settings_3) $wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_settings SET item='remove_external_links' , value='0'  ");

$check_settings_4=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_settings WHERE item='system_key' " );
if(!$check_settings_4) $wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_settings SET item='system_key' , value=''  ");
	
	
$check_settings_5=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_settings WHERE item='customized_post' " );
if(!$check_settings_5) $wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_settings SET item='customized_post' , value='1'  ");	


update_option( "smartbot_version", $smartbot_version );
}
//-------------------



//-------------------
function smartbot_update_db() {
    global $smartbot_version;
    if ( get_site_option('smartbot_version') != $smartbot_version ) {
        insert_db_smartbot();
    }
}
//-------------------
	


//-------------------
function tr_num_fun($str,$mod='en',$mf='٫'){
 $num_a=array('0','1','2','3','4','5','6','7','8','9','.');
 $key_a=array('۰','۱','۲','۳','۴','۵','۶','۷','۸','۹',$mf);
 return($mod=='fa')?str_replace($num_a,$key_a,$str):str_replace($key_a,$num_a,$str);
}
//-------------------


//-------------------
function jalali_to_gregorian_fun($j_y,$j_m,$j_d,$mod=''){
 $g_y=tr_num_fun($j_y); $j_m=tr_num_fun($j_m); $j_d=tr_num_fun($j_d);/* <= :اين سطر ، جزء تابع اصلي نيست */
 $d_4=($j_y+1)%4;
 $doy_j=($j_m<7)?(($j_m-1)*31)+$j_d:(($j_m-7)*30)+$j_d+186;
 $d_33=(int)((($j_y-55)%132)*.0305);
 $a=($d_33!=3 and $d_4<=$d_33)?287:286;
 $b=(($d_33==1 or $d_33==2) and ($d_33==$d_4 or $d_4==1))?78:(($d_33==3 and $d_4==0)?80:79);
 if((int)(($j_y-19)/63)==20){$a--;$b++;}
 if($doy_j<=$a){
  $gy=$j_y+621; $gd=$doy_j+$b;
 }else{
  $gy=$j_y+622; $gd=$doy_j-$a;
 }
 foreach(array(0,31,($gy%4==0)?29:28,31,30,31,30,31,31,30,31,30,31) as $gm=>$v){
  if($gd<=$v)break;
  $gd-=$v;
 }
 return($mod=='')?array($gy,$gm,$gd):$gy.$mod.$gm.$mod.$gd;
}
//-------------------


//-------------------
function saveimage($imgSrc,$thumbnail_width,$thumbnail_height) { 
 
    list($width_orig, $height_orig) = getimagesize($imgSrc); 
	
	if(!$thumbnail_width) $thumbnail_width=$width_orig;
	if(!$thumbnail_height) $thumbnail_height=$height_orig;
	  
    $myImage = imagecreatefromjpeg($imgSrc);
    $ratio_orig = $width_orig/$height_orig;
    
    if ($thumbnail_width/$thumbnail_height > $ratio_orig) {
       $new_height = $thumbnail_width/$ratio_orig;
       $new_width = $thumbnail_width;
    } else {
       $new_width = $thumbnail_height*$ratio_orig;
       $new_height = $thumbnail_height;
    }
    
    $x_mid = $new_width/2;  //horizontal middle
    $y_mid = $new_height/2; //vertical middle
    
    $process = imagecreatetruecolor(round($new_width), round($new_height)); 
    
    $st1=imagecopyresampled($process, $myImage, 0, 0, 0, 0, $new_width, $new_height, $width_orig, $height_orig);
    $thumb = imagecreatetruecolor($thumbnail_width, $thumbnail_height); 
    $st2=imagecopyresampled($thumb, $process, 0, 0, ($x_mid-($thumbnail_width/2)), ($y_mid-($thumbnail_height/2)), $thumbnail_width, $thumbnail_height, $thumbnail_width, $thumbnail_height);

    imagedestroy($process);
    imagedestroy($myImage);
	
	if($st1 AND $st2)
    return $thumb;
	else
	return false;
	
}
//-------------------



//-------------------
function run_robot() {	
global  $wpdb;

$half_minute_ago=time()-30;

$smartbot_crawls_count=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_crawls WHERE time>".$half_minute_ago." LIMIT 0,1 " );
if(!$smartbot_crawls_count) {
	

// GET SETTINGS -------------------	
$smartbot_settings = $wpdb->get_results( "SELECT item,value FROM ".$wpdb->prefix."smartbot_settings ");
foreach ( $smartbot_settings as $ddd ) {
if($ddd->item=='posts_status') $posts_status_setting=$ddd->value;
if($ddd->item=='insert_reporter_name') $insert_reporter_name_setting=$ddd->value;
if($ddd->item=='remove_external_links') $remove_external_links_setting=$ddd->value;
if($ddd->item=='system_key') $system_key_setting=$ddd->value;
if($ddd->item=='customized_post') $customized_post=$ddd->value;	
}
//__GET SETTINGS -------------------	
	

// SELECT TAG -------------------
$number_of_tags=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_tags ");
$rotation_time=$number_of_tags*60;


$period_crawl=time()-$rotation_time;
$selected_tag=null;

$smartbot_tags= $wpdb->get_results( "SELECT ID,keywords,term_id,thumbnail_width,thumbnail_height FROM ".$wpdb->prefix."smartbot_tags order by id  ");
foreach ($smartbot_tags as $sss ) {
if(!$selected_tag) {	
$smartbot_crawls_count2 =$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_crawls WHERE time>".$period_crawl." AND tag_id=".$sss->ID."" );
if(!$smartbot_crawls_count2) { 
$selected_tag=$sss->keywords; 
$selected_tag_id=$sss->ID; 
$related_categories=$sss->term_id;
$thumbnail_width=$sss->thumbnail_width;
$thumbnail_height=$sss->thumbnail_height;
}		
}
}
// __SELECT TAG -------------------


if($selected_tag) {

	
// CREATE WEB SERVICE URL ------------------- 	
$addr_rss='http://engine.smartbot.ir/service.php?key='.$system_key_setting.'&customized='.$customized_post.'&minute='.$number_of_tags.'&references=';

$xx=0;

$smartbot_sources = $wpdb->get_results("SELECT address FROM ".$wpdb->prefix."smartbot_sources order by id ");
foreach ( $smartbot_sources as $eee ) {
	
if($xx!=0)
$addr_rss.=',';	
	
$addr_rss.=$eee->address;
$xx++;
}

$addr_rss.='&subject='.$selected_tag;
// __CREATE WEB SERVICE URL ------------------- 


$wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_crawls SET time=".time()." , tag_id=".$selected_tag_id."  ");


// LOAD XML -------------------
$xml=simplexml_load_file($addr_rss);
$number_items=$xml->channel->item->count();
// __LOAD XML -------------------



// WHILE (ITEMS OF XML FILE) -------------------------------------------------------------------
$start=0;
while($start<$number_items) {
	
$id=$xml->channel->item[$start]->id;

$smartbot_crawls_posts_count=$wpdb->get_var( "SELECT COUNT(*) FROM ".$wpdb->prefix."smartbot_posts WHERE system_id=".$id." " );
if(!$smartbot_crawls_posts_count) {	
	
//  DATE ------------------		
$date=$xml->channel->item[$start]->pubDate;
$date_arr=explode(' ',$date);
$day_arr=explode('/',$date_arr[0]);
$clock_arr=explode(':',$date_arr[1]);


$seconds_of_day=($clock_arr[0] * 3600) + ($clock_arr[1] *60);

$gregorian=jalali_to_gregorian_fun($day_arr[0],$day_arr[1],$day_arr[2],'-');
$time_of_news=strtotime($gregorian)+$seconds_of_day;
// __DATE ------------------


//  MODIFY POST ------------------	
if($remove_external_links_setting==1) {
$temp_body= preg_replace('/href=\"http:\/\/www\.yjc\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $xml->channel->item[$start]->body);
$temp_body= preg_replace('/href=\"http:\/\/yjc\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.iribnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/iribnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.iqna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/iqna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.snn\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/snn\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.bornanews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/bornanews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.fa\.alalam\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/fa\.alalam\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.presstv\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/presstv\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.dana\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/dana\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.asriran\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/asriran\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.entekhab\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/entekhab\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.nasimonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/nasimonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.jamejamonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/jamejamonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.rajanews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/rajanews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.afkarnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/afkarnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.parsnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/parsnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.etedaal\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/etedaal\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.jahannews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/jahannews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.jamaran\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/jamaran\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.baharnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/baharnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.faradeed\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/faradeed\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.roozno\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/roozno\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.mehrnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/mehrnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.irna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/irna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);


$temp_body= preg_replace('/href=\"http:\/\/www\.isna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/isna\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.tasnimnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/tasnimnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.bartarinha\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/bartarinha\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);



$temp_body= preg_replace('/href=\"http:\/\/www\.farsnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/farsnews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.mizanonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/mizanonline\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.tabnak\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/tabnak\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.mashreghnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/mashreghnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.parsine\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/parsine\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.aftabnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/aftabnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.shia-news\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/shia-news\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.boursenews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/boursenews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.seratnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/seratnews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.shafaf\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/shafaf\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.fardanews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/fardanews\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.bultannews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/bultannews\.com([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.598\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/598\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);

$temp_body= preg_replace('/href=\"http:\/\/www\.kayhan\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
$temp_body= preg_replace('/href=\"http:\/\/kayhan\.ir([^>]*)\">/i', 'href="'.get_option('siteurl').'">', $temp_body);
}
else 
$temp_body=$xml->channel->item[$start]->body;


if($insert_reporter_name_setting==1)
$temp_body=str_replace('به گزارش','به گزارش '.get_option('blogname').' به نقل از ',$temp_body);
// __MODIFY POST ------------------


//  STATUS OF POST ------------------
if($posts_status_setting==1) $status_of_article='publish';
else $status_of_article='draft';
// __STATUS OF POST ------------------


//  INSERT POST ------------------
kses_remove_filters();

$my_post = array(
  'post_title'    => $xml->channel->item[$start]->title,
  'post_content'  => $temp_body,
  'post_status'   => $status_of_article,
  'post_category' => array( $related_categories )
);

$post_id =wp_insert_post( $my_post );

kses_init_filters();

$post_rutitr=sanitize_text_field($xml->channel->item[$start]->subtitle);

if($post_rutitr)
add_post_meta($post_id, 'post_rutitr', $post_rutitr);
// __INSERT POST ------------------



// Get the path to the upload directory.
$wp_upload_dir = wp_upload_dir();

$path_save_temp=null;
$path_save=null;
$status_save=null;


// UPLOAD PICTURE ------------------
$picture=$xml->channel->item[$start]->image;

if($picture) {
	
$random_name=rand(9999999,99999999999);
$path_save_temp=$wp_upload_dir['path'].'/'.$random_name.'.jpg';

$ch = curl_init($picture);
$fp = fopen($path_save_temp, 'wb');
curl_setopt($ch, CURLOPT_FILE, $fp);
curl_setopt($ch, CURLOPT_HEADER, 0);
curl_exec($ch);
curl_close($ch);
fclose($fp);		
	
$img = saveimage($path_save_temp,$thumbnail_width,$thumbnail_height);

$random_name=rand(9999999,99999999999);
$path_save=$wp_upload_dir['path'].'/'.$random_name.'.jpg';

if($img) {	
$status_save=imagejpeg($img,$path_save);
imagedestroy($img);
}	

unlink($path_save_temp);
}
// __UPLOAD PICTURE ------------------



// SET ATTACHEMENT ------------------
if($status_save) {
	
$parent_post_id = $post_id;

// Check the type of file. We'll use this as the 'post_mime_type'.
$filetype = wp_check_filetype( basename( $path_save ), null );


// Prepare an array of post data for the attachment.
$attachment = array(
	'guid'           => $wp_upload_dir['url'] . '/' . basename( $path_save ), 
	'post_mime_type' => $filetype['type'],
	'post_title'     => preg_replace( '/\.[^.]+$/', '', basename( $path_save ) ),
	'post_content'   => '',
	'post_status'    => 'inherit'
);

// Insert the attachment.
$attach_id = wp_insert_attachment( $attachment, $path_save, $parent_post_id );

// Make sure that this file is included, as wp_generate_attachment_metadata() depends on it.
require_once( ABSPATH . 'wp-admin/includes/image.php' );

// Generate the metadata for the attachment, and update the database record.
$attach_data = wp_generate_attachment_metadata( $attach_id, $path_save );
wp_update_attachment_metadata( $attach_id, $attach_data );

set_post_thumbnail( $parent_post_id, $attach_id );
}
// __SET ATTACHEMENT ------------------



$wpdb->query("INSERT INTO ".$wpdb->prefix."smartbot_posts SET system_id=".$id." , post_id=".$post_id."  ");
} 


$start++;
}

}	  
	  
}

}
//-------------------